# Notification Callback

For security reason, we highly recommend Merchant to ensure that the notifications received by Merchant backend, are actually sent by Finpay system. There are two ways to do those activity:

1. Validate the response by request checking transaction status to Finpay using Check Status Service. This flow is the most secure method to verify the authenticity of Callback. If transaction status match with Callback then Merchant can continue process the order
2. Validate the response using a comparison of the signature key receive from Finpay system when sending Callback with the signature generated by Merchant them self. If the siganture key does not match please ignore callback send by Finpay and you dont need to process the transaction.

Here are logic of the Signature Key to generate the Signature Key:

```
hash_hmac("sha512", json_encode($fields), $key);
```

| Method | Merchant URL                     |
| ------ | -------------------------------- |
| POST   | <https://url.callback.merchant/> |

### Data Request <a href="#data-request" id="data-request"></a>

| No | Name                       | Type                                                                    | Mandatory | Min Length | Max Length | Description                                                                                                                                                                                                                                                             |
| -- | -------------------------- | ----------------------------------------------------------------------- | --------- | ---------- | ---------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 1  | transactionDate            | String                                                                  | O         | 1          | 50         | ISO 8601 format                                                                                                                                                                                                                                                         |
| 2  | transferDateTime           | String                                                                  | M         | 1          | 50         | Actual transfer date time ISO 8601 format                                                                                                                                                                                                                               |
| 3  | originalReferenceNo        | String                                                                  | M         | 1          | 64         | Original transaction identifier on service provider system                                                                                                                                                                                                              |
| 4  | originalPartnerReferanceNo | String                                                                  | O         | 1          | 64         | Original Transaction identifier on service consumer system                                                                                                                                                                                                              |
| 5  | beneficiaryBackCode        | String                                                                  | M         | 1          | 6          | Original beneficiary bank code on service provider system                                                                                                                                                                                                               |
| 6  | beneficiaryAccountName     | String                                                                  | M         | 1          | 64         | Original beneficiary account name on service provider system                                                                                                                                                                                                            |
| 7  | beneficiaryAccountNo       | String                                                                  | M         | 1          | 64         | Original beneficiary account number on service provider system                                                                                                                                                                                                          |
| 8  | amount                     | [Object](/api-reference/appendix/json-object/amount-object.md)          | O         | 1          | 2          | Detail of amount                                                                                                                                                                                                                                                        |
| 9  | latestTransactionStatus    | String                                                                  | M         | 1          | 2          | <p><code>00 - Success</code> </p><p><code>01 - Initiated</code> </p><p><code>02 - Paying</code></p><p><code>03 - Pending</code></p><p><code>04 - Refunded</code></p><p><code>05 - Cancelled</code></p><p><code>06 - Failed</code></p><p><code>07 - Not found</code></p> |
| 10 | triggerType                | String                                                                  | M         | 1          | 9          | Type of Notification: - automatic (updated by system) - manual (triggered by merchant/operation)                                                                                                                                                                        |
| 11 | additionalInfo             | [Object](/api-reference/appendix/json-object/additional-info-object.md) | O         | 1          | 18         | Additional Info                                                                                                                                                                                                                                                         |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "transactionDate": "2025-06-25T16:43:41+07:00",
  "transferDateTime": "2025-06-25T16:43:44+07:00",
  "originalReferenceNo": "20250625164341499267",
  "originalPartnerReferenceNo": "f6c1bf23-8c86-4241-a445-591275d7efb0",
  "beneficiaryBankCode": "91122",
  "beneficiaryAccountName": "AHMAD ARIFAI",
  "beneficiaryAccountNo": "3205309801",
  "amount": {
    "currency": "IDR",
    "value": "3036663.00"
  },
  "latestTransactionStatus": "00",
  "triggerType": "automatic",
  "additionalInfo": {
    "notes": null
  }
}
```

### Data Response <a href="#data-response" id="data-response"></a>

| No | Name            | Type                                                              | Mandatory | Min Length | Max Length | Description      |
| -- | --------------- | ----------------------------------------------------------------- | --------- | ---------- | ---------- | ---------------- |
| 1  | responseCode    | [Enum](/api-reference/appendix/enumeration/response-code-list.md) | M         | 1          | 7          | Response Code    |
| 2  | responseMessage | String                                                            | M         | 1          | 500        | Response Message |
| 3  | processingTime  | Number                                                            | M         | 1          | 20         | Processing Time  |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2000000",
  "responseMessage": "Success",
  "processingTime": 0.6609270572662354
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-disbursement/direct-integration-core-api/notification-callback.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
